// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_client

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// DIDClient is the client API for DID service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DIDClient interface {
	//Получить список зон покупки номера с обязательными свойствами
	GetLocalitiesByFeatures(ctx context.Context, in *LocalityConstraints, opts ...grpc.CallOption) (DID_GetLocalitiesByFeaturesClient, error)
	//Получить список стран
	ListAvailableCountries(ctx context.Context, in *Language, opts ...grpc.CallOption) (DID_ListAvailableCountriesClient, error)
	//Получить список зон покупки номера
	ListAvailableLocalities(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_ListAvailableLocalitiesClient, error)
	//Получить список возможных номеров для покупки
	ListAvailableNumbers(ctx context.Context, in *DidLocality, opts ...grpc.CallOption) (DID_ListAvailableNumbersClient, error)
	//Арендовать номер
	RequestNumber(ctx context.Context, in *DidOffer, opts ...grpc.CallOption) (*DidRequest, error)
	//Освободить номер (важен только id)
	ReleaseNumber(ctx context.Context, in *DidNumber, opts ...grpc.CallOption) (*api.Empty, error)
	//Получить список арендованых номеров и продолжать мониторинг streamed=1
	GetNumbers(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_GetNumbersClient, error)
	//Получить список отложеных предложений в корзине
	GetBasket(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_GetBasketClient, error)
	//Удалить из корзины предложение (важен только id)
	RemoveBasket(ctx context.Context, in *OfferBasket, opts ...grpc.CallOption) (*OfferBasket, error)
	//Добавить в корзину предложение
	AddBasket(ctx context.Context, in *DidOffer, opts ...grpc.CallOption) (*OfferBasket, error)
}

type dIDClient struct {
	cc grpc.ClientConnInterface
}

func NewDIDClient(cc grpc.ClientConnInterface) DIDClient {
	return &dIDClient{cc}
}

func (c *dIDClient) GetLocalitiesByFeatures(ctx context.Context, in *LocalityConstraints, opts ...grpc.CallOption) (DID_GetLocalitiesByFeaturesClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[0], "/com.freeje.api.client.DID/GetLocalitiesByFeatures", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDGetLocalitiesByFeaturesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_GetLocalitiesByFeaturesClient interface {
	Recv() (*DidLocality, error)
	grpc.ClientStream
}

type dIDGetLocalitiesByFeaturesClient struct {
	grpc.ClientStream
}

func (x *dIDGetLocalitiesByFeaturesClient) Recv() (*DidLocality, error) {
	m := new(DidLocality)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) ListAvailableCountries(ctx context.Context, in *Language, opts ...grpc.CallOption) (DID_ListAvailableCountriesClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[1], "/com.freeje.api.client.DID/ListAvailableCountries", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDListAvailableCountriesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_ListAvailableCountriesClient interface {
	Recv() (*DidCountry, error)
	grpc.ClientStream
}

type dIDListAvailableCountriesClient struct {
	grpc.ClientStream
}

func (x *dIDListAvailableCountriesClient) Recv() (*DidCountry, error) {
	m := new(DidCountry)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) ListAvailableLocalities(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_ListAvailableLocalitiesClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[2], "/com.freeje.api.client.DID/ListAvailableLocalities", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDListAvailableLocalitiesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_ListAvailableLocalitiesClient interface {
	Recv() (*DidLocality, error)
	grpc.ClientStream
}

type dIDListAvailableLocalitiesClient struct {
	grpc.ClientStream
}

func (x *dIDListAvailableLocalitiesClient) Recv() (*DidLocality, error) {
	m := new(DidLocality)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) ListAvailableNumbers(ctx context.Context, in *DidLocality, opts ...grpc.CallOption) (DID_ListAvailableNumbersClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[3], "/com.freeje.api.client.DID/ListAvailableNumbers", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDListAvailableNumbersClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_ListAvailableNumbersClient interface {
	Recv() (*DidOffer, error)
	grpc.ClientStream
}

type dIDListAvailableNumbersClient struct {
	grpc.ClientStream
}

func (x *dIDListAvailableNumbersClient) Recv() (*DidOffer, error) {
	m := new(DidOffer)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) RequestNumber(ctx context.Context, in *DidOffer, opts ...grpc.CallOption) (*DidRequest, error) {
	out := new(DidRequest)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.DID/RequestNumber", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *dIDClient) ReleaseNumber(ctx context.Context, in *DidNumber, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.DID/ReleaseNumber", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *dIDClient) GetNumbers(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_GetNumbersClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[4], "/com.freeje.api.client.DID/GetNumbers", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDGetNumbersClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_GetNumbersClient interface {
	Recv() (*DidNumber, error)
	grpc.ClientStream
}

type dIDGetNumbersClient struct {
	grpc.ClientStream
}

func (x *dIDGetNumbersClient) Recv() (*DidNumber, error) {
	m := new(DidNumber)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) GetBasket(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (DID_GetBasketClient, error) {
	stream, err := c.cc.NewStream(ctx, &DID_ServiceDesc.Streams[5], "/com.freeje.api.client.DID/GetBasket", opts...)
	if err != nil {
		return nil, err
	}
	x := &dIDGetBasketClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DID_GetBasketClient interface {
	Recv() (*OfferBasket, error)
	grpc.ClientStream
}

type dIDGetBasketClient struct {
	grpc.ClientStream
}

func (x *dIDGetBasketClient) Recv() (*OfferBasket, error) {
	m := new(OfferBasket)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *dIDClient) RemoveBasket(ctx context.Context, in *OfferBasket, opts ...grpc.CallOption) (*OfferBasket, error) {
	out := new(OfferBasket)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.DID/RemoveBasket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *dIDClient) AddBasket(ctx context.Context, in *DidOffer, opts ...grpc.CallOption) (*OfferBasket, error) {
	out := new(OfferBasket)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.DID/AddBasket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DIDServer is the server API for DID service.
// All implementations should embed UnimplementedDIDServer
// for forward compatibility
type DIDServer interface {
	//Получить список зон покупки номера с обязательными свойствами
	GetLocalitiesByFeatures(*LocalityConstraints, DID_GetLocalitiesByFeaturesServer) error
	//Получить список стран
	ListAvailableCountries(*Language, DID_ListAvailableCountriesServer) error
	//Получить список зон покупки номера
	ListAvailableLocalities(*api.RequestMode, DID_ListAvailableLocalitiesServer) error
	//Получить список возможных номеров для покупки
	ListAvailableNumbers(*DidLocality, DID_ListAvailableNumbersServer) error
	//Арендовать номер
	RequestNumber(context.Context, *DidOffer) (*DidRequest, error)
	//Освободить номер (важен только id)
	ReleaseNumber(context.Context, *DidNumber) (*api.Empty, error)
	//Получить список арендованых номеров и продолжать мониторинг streamed=1
	GetNumbers(*api.RequestMode, DID_GetNumbersServer) error
	//Получить список отложеных предложений в корзине
	GetBasket(*api.RequestMode, DID_GetBasketServer) error
	//Удалить из корзины предложение (важен только id)
	RemoveBasket(context.Context, *OfferBasket) (*OfferBasket, error)
	//Добавить в корзину предложение
	AddBasket(context.Context, *DidOffer) (*OfferBasket, error)
}

// UnimplementedDIDServer should be embedded to have forward compatible implementations.
type UnimplementedDIDServer struct {
}

func (UnimplementedDIDServer) GetLocalitiesByFeatures(*LocalityConstraints, DID_GetLocalitiesByFeaturesServer) error {
	return status.Errorf(codes.Unimplemented, "method GetLocalitiesByFeatures not implemented")
}
func (UnimplementedDIDServer) ListAvailableCountries(*Language, DID_ListAvailableCountriesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListAvailableCountries not implemented")
}
func (UnimplementedDIDServer) ListAvailableLocalities(*api.RequestMode, DID_ListAvailableLocalitiesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListAvailableLocalities not implemented")
}
func (UnimplementedDIDServer) ListAvailableNumbers(*DidLocality, DID_ListAvailableNumbersServer) error {
	return status.Errorf(codes.Unimplemented, "method ListAvailableNumbers not implemented")
}
func (UnimplementedDIDServer) RequestNumber(context.Context, *DidOffer) (*DidRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RequestNumber not implemented")
}
func (UnimplementedDIDServer) ReleaseNumber(context.Context, *DidNumber) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReleaseNumber not implemented")
}
func (UnimplementedDIDServer) GetNumbers(*api.RequestMode, DID_GetNumbersServer) error {
	return status.Errorf(codes.Unimplemented, "method GetNumbers not implemented")
}
func (UnimplementedDIDServer) GetBasket(*api.RequestMode, DID_GetBasketServer) error {
	return status.Errorf(codes.Unimplemented, "method GetBasket not implemented")
}
func (UnimplementedDIDServer) RemoveBasket(context.Context, *OfferBasket) (*OfferBasket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveBasket not implemented")
}
func (UnimplementedDIDServer) AddBasket(context.Context, *DidOffer) (*OfferBasket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddBasket not implemented")
}

// UnsafeDIDServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DIDServer will
// result in compilation errors.
type UnsafeDIDServer interface {
	mustEmbedUnimplementedDIDServer()
}

func RegisterDIDServer(s grpc.ServiceRegistrar, srv DIDServer) {
	s.RegisterService(&DID_ServiceDesc, srv)
}

func _DID_GetLocalitiesByFeatures_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(LocalityConstraints)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).GetLocalitiesByFeatures(m, &dIDGetLocalitiesByFeaturesServer{stream})
}

type DID_GetLocalitiesByFeaturesServer interface {
	Send(*DidLocality) error
	grpc.ServerStream
}

type dIDGetLocalitiesByFeaturesServer struct {
	grpc.ServerStream
}

func (x *dIDGetLocalitiesByFeaturesServer) Send(m *DidLocality) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_ListAvailableCountries_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Language)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).ListAvailableCountries(m, &dIDListAvailableCountriesServer{stream})
}

type DID_ListAvailableCountriesServer interface {
	Send(*DidCountry) error
	grpc.ServerStream
}

type dIDListAvailableCountriesServer struct {
	grpc.ServerStream
}

func (x *dIDListAvailableCountriesServer) Send(m *DidCountry) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_ListAvailableLocalities_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).ListAvailableLocalities(m, &dIDListAvailableLocalitiesServer{stream})
}

type DID_ListAvailableLocalitiesServer interface {
	Send(*DidLocality) error
	grpc.ServerStream
}

type dIDListAvailableLocalitiesServer struct {
	grpc.ServerStream
}

func (x *dIDListAvailableLocalitiesServer) Send(m *DidLocality) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_ListAvailableNumbers_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(DidLocality)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).ListAvailableNumbers(m, &dIDListAvailableNumbersServer{stream})
}

type DID_ListAvailableNumbersServer interface {
	Send(*DidOffer) error
	grpc.ServerStream
}

type dIDListAvailableNumbersServer struct {
	grpc.ServerStream
}

func (x *dIDListAvailableNumbersServer) Send(m *DidOffer) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_RequestNumber_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DidOffer)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DIDServer).RequestNumber(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.DID/RequestNumber",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DIDServer).RequestNumber(ctx, req.(*DidOffer))
	}
	return interceptor(ctx, in, info, handler)
}

func _DID_ReleaseNumber_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DidNumber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DIDServer).ReleaseNumber(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.DID/ReleaseNumber",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DIDServer).ReleaseNumber(ctx, req.(*DidNumber))
	}
	return interceptor(ctx, in, info, handler)
}

func _DID_GetNumbers_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).GetNumbers(m, &dIDGetNumbersServer{stream})
}

type DID_GetNumbersServer interface {
	Send(*DidNumber) error
	grpc.ServerStream
}

type dIDGetNumbersServer struct {
	grpc.ServerStream
}

func (x *dIDGetNumbersServer) Send(m *DidNumber) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_GetBasket_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DIDServer).GetBasket(m, &dIDGetBasketServer{stream})
}

type DID_GetBasketServer interface {
	Send(*OfferBasket) error
	grpc.ServerStream
}

type dIDGetBasketServer struct {
	grpc.ServerStream
}

func (x *dIDGetBasketServer) Send(m *OfferBasket) error {
	return x.ServerStream.SendMsg(m)
}

func _DID_RemoveBasket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(OfferBasket)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DIDServer).RemoveBasket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.DID/RemoveBasket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DIDServer).RemoveBasket(ctx, req.(*OfferBasket))
	}
	return interceptor(ctx, in, info, handler)
}

func _DID_AddBasket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DidOffer)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DIDServer).AddBasket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.DID/AddBasket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DIDServer).AddBasket(ctx, req.(*DidOffer))
	}
	return interceptor(ctx, in, info, handler)
}

// DID_ServiceDesc is the grpc.ServiceDesc for DID service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var DID_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.client.DID",
	HandlerType: (*DIDServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "RequestNumber",
			Handler:    _DID_RequestNumber_Handler,
		},
		{
			MethodName: "ReleaseNumber",
			Handler:    _DID_ReleaseNumber_Handler,
		},
		{
			MethodName: "RemoveBasket",
			Handler:    _DID_RemoveBasket_Handler,
		},
		{
			MethodName: "AddBasket",
			Handler:    _DID_AddBasket_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetLocalitiesByFeatures",
			Handler:       _DID_GetLocalitiesByFeatures_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListAvailableCountries",
			Handler:       _DID_ListAvailableCountries_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListAvailableLocalities",
			Handler:       _DID_ListAvailableLocalities_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListAvailableNumbers",
			Handler:       _DID_ListAvailableNumbers_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetNumbers",
			Handler:       _DID_GetNumbers_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetBasket",
			Handler:       _DID_GetBasket_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "client/did.proto",
}
